﻿Imports System.Text
Imports System.ComponentModel.Composition

Namespace VsSpeakerCompanion
	''' <summary>
	''' Decorates an <see cref="IWidgetProvider"/> to specify its Name and Order (Before or After)
	''' </summary>
	<MetadataAttribute, AttributeUsage(AttributeTargets.Class, AllowMultiple:=False)>
	Public Class WidgetAttribute
		Inherits Attribute
		''' <summary>
		''' Gets or sets the Name of the widget provider
		''' </summary>
        Public Property Name As String

		''' <summary>
		''' Gets or sets before which widget provider should be added the widgets
		''' </summary>
        Public Property Before As String

		''' <summary>
		''' Gets or sets after which widget provider should be added the widgets
		''' </summary>
        Public Property After As String
	End Class
End Namespace
