﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using VsSpeakerCompanion;
using System.ComponentModel.Composition;
using Microsoft.VisualStudio.Text.Editor;
using Microsoft.VisualStudio.Text.Classification;
using TwitterAPI;
using VsSpeakerCompanion.UI;

namespace FontSizeWidget
{
    [Export(typeof(IWidgetProvider))]
    [Widget(Name="Font Size Widget", After = "Sound Snippet Widget")]
    class FontSizeWidgetProvider : IWidgetProvider
    {
        [Import]
        private IWidgetAnimationService widgetAnimationService { get; set; }

        [Import]
        private IVisualStudioService visualStudioService { get; set; }

        [Import]
        private IEditorFormatMapService _editorFormatMapService { get; set; }

        [Import]
        private TwitterService TwitterService { get; set; }

        [Import]
        private IServiceProvider serviceProvider { get; set; }
        
        public IEnumerable<IWidget>  GetWidgets(Context context)
        {
            return new List<IWidget> { new FontSizeWidget(visualStudioService, _editorFormatMapService, TwitterService, widgetAnimationService, serviceProvider) };
        }
    }
}
