﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Timers;
using TwitterAPI;
using System.Windows;
using VsSpeakerCompanion;
using System.ComponentModel.Composition;
using System.Windows.Threading;
using VsSpeakerCompanion.UI;

namespace SpeedWidget
{
    [Export(typeof(IWidgetProvider))]
    [Widget(Name = "Speed Widget")]
    internal class WidgetProvider : IWidgetProvider
    {
        IEnumerable<IWidget> IWidgetProvider.GetWidgets(Context context)
        {
            // creates an instance of the SpeedWidget and pass to it the two services it will require to run
            Widget widget = new Widget(this.TwitterService, widgetAnimationService);

            return new List<IWidget> { widget };
        }

        [Import]
        private TwitterService TwitterService { get; set; }

        [Import]
        private IWidgetAnimationService widgetAnimationService { get; set; }
    }
}