﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

namespace VsSpeakerCompanion
{
    /// <summary>
    /// Represents a widget offering some functionality for speakers.
    /// </summary>
    public interface IWidget
    {
        /// <summary>
        /// Resets the internal state of the widget
        /// </summary>
        void Reset();
        
        /// <summary>
        /// Gets the visual representation of the widget. This is optional.
        /// </summary>
        UIElement VisualElement { get; }
    }
}
