﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.Composition;

namespace VsSpeakerCompanion
{
    /// <summary>
    /// Decorates an <see cref="IWidgetProvider"/> to specify its Name and Order (Before or After)
    /// </summary>
    [MetadataAttribute]
    [AttributeUsage(AttributeTargets.Class, AllowMultiple=false)]
    public class WidgetAttribute : Attribute
    {
        /// <summary>
        /// Gets or sets the Name of the widget provider
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets before which widget provider should be added the widgets
        /// </summary>
        public string Before { get; set; }

        /// <summary>
        /// Gets or sets after which widget provider should be added the widgets
        /// </summary>
        public string After { get; set; }
    }
}
